struct triangle_s {
	uint32_t lasttick;
	uint16_t lengthcounter;
	uint16_t lengthindex;
	uint8_t lengthhalt; //also control flag
	uint32_t period;
	uint32_t linearcounter;
	uint16_t linearreload;
	uint8_t seqstep;
	uint8_t enabled;
};

struct square_s {
	uint32_t lasttick;
	uint16_t lengthcounter;
	uint16_t lengthindex;
	uint16_t envelope;
	uint16_t constant;
	uint8_t lengthhalt;
	uint16_t sweep;
	uint32_t period;
	uint16_t negate;
	uint16_t shift;
	uint8_t sweepenable;
	uint32_t sweepresult;
	uint8_t sweepreload;
	uint8_t sweepperiod;
	uint8_t duty;
	uint8_t dutypos;
	uint8_t wrotebit4;
	uint8_t envloop;
	uint8_t enabled;
};

struct noise_s {
	uint32_t lasttick;
	uint16_t lengthcounter;
	uint16_t lengthindex;
	uint16_t envelope;
	uint8_t lengthhalt;
	uint32_t period;
	uint16_t shift;
	uint8_t enabled;
	uint8_t constant;
	uint8_t envreload;
	uint8_t wrotebit4;
	uint8_t mode;
};

struct dmc_s {
	uint32_t lasttick;
	uint32_t period;
	uint8_t samplebuffer;
	uint8_t bufferbit;
	uint8_t sampleempty;
	uint16_t bytesremain;
	uint16_t lengthreg;
	uint16_t address;
	uint16_t addressreg;
	uint8_t loopmode;
	uint8_t enabled;
};

#define CPU_NTSC 1789773
#define CPU_PAL  1662607
