#ifdef _WIN32
	#include "resource.h"
	#include "SDL/include/SDL.h"
	#define _WIN32_WINNT 0x400
	#include <windows.h>
	#define getfreq(x) { QueryPerformanceFrequency(&dummytimer); x = dummytimer.QuadPart; }
	#define getclock(x) { QueryPerformanceCounter(&dummytimer); x = dummytimer.QuadPart; }
#else
	#include <SDL/SDL.h>
	#include <time.h>
	#define getfreq(x) x = 1000000
	#define getclock(x) {\
		gettimeofday(&timestr, NULL);\
		x = timestr.tv_sec * 1000000 + timestr.tv_usec;\
	}
#endif
